#ifndef BEAM__H
#define BEAM__H

#include <vector>
#include <string>
#include "BaseConfig.hpp"
#include "ReadingMachine.hpp"

class Beam
{
  public :

  class Element
  {
    public :

    BaseConfig config;
    int nextTransition;
    float totalProbability;
    std::string name;
    bool ended{false};

    public :

    Element(BaseConfig & model, int nextTransition, float totalProbability, std::string name);
  };

  private :

  std::size_t width;
  float threshold;
  std::vector<Element> elements;
  bool ended{false};

  public :

  Beam(std::size_t width, float threshold, BaseConfig & model, const ReadingMachine & machine);
  Element & operator[](std::size_t index);
  void update(ReadingMachine & machine, bool debug);
  bool isEnded() const;
};

#endif
